MAIN PROBLEM WAS THAT 10-YR AGECATS ARE TOO LONG -- CHANGED TO 5-YR HERE
OTHER ISSUES ARE NOTED BELOW

use diabetes , clear
gen exitage = entryage + futime/365.25
gen older = dxage > 20
egen dxacat = cut(dxage) , at(0 (10) 100)
stset exitage , failure(status==1) enter(time entryage) id(id)
stsplit agecat , at (10(5)100)   // decreased intervals to 5 yrs
gen died = _d
gen risktime = _t - _t0
// added dxacat to the by( ) list  -- definitly the right way but did not matter much here
collapse (rawsum) died risktime (mean) dxage exitage [w = risktime], by(agecat older dxacat)
gen logage = log(exitage/55)
gen logage2 = logage*logage
poisson died logage logage2 older , exposure(risktime)
gen older_by_age = older * logage 
poisson died logage logage2 older older_by_age, exposure(risktime)


use diabetes , clear
gen exitage = entryage + futime/365.25
gen older = dxage > 20
stset exitage , failure(status==1) enter(time entryage) id(id)
stsplit agecat , at (10(5)100)
gen died = _d
gen risktime = _t - _t0
// there are 2 ways to access exit ages --- not sure which is best
//  (probably the first way here, but with more narrow agecats does not matter much
//  using 5-yr here, for viewing the table, but even better to use 1-yr
gen logage = log(exitage/55)
gen logage2 = logage*logage
gen logamod = log((agecat + 2.5)/55)  // the other way
gen loga2mod = logamod*logamod
// these 2 give very different pvals for older, unless stplit is finer than 10-yr
// it seems that the second way agrees better with the collapsed analysis
//    probably because the collapsed analysis makes use of both exitage and agecat 
poisson died logage logage2 older , exposure(risktime)
poisson died logamod loga2mod older, exposure(risktime)
gen older_by_age = older * logamod
poisson died logamod loga2mod older older_by_age, exposure(risktime)



